using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Threading;
using System.IO;

using System.Text;
using System.Text.RegularExpressions;
using System.Drawing.Imaging;

namespace PhidgetHealth
{

	public class HistoryPhotoForm : System.Windows.Forms.Form
	{
		#region GUIR|[lg̐錾
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Panel panelGraph;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.DateTimePicker dateTimePickerStart;
		private System.Windows.Forms.ComboBox comboBoxRange;
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Button buttonUpdate;
		private System.Windows.Forms.ComboBox comboBoxSpan;
		private System.Windows.Forms.Panel panelPhoto;
		private System.Windows.Forms.Label labelCurrentDay;
		private System.Windows.Forms.Button buttonExport;
		private System.Windows.Forms.GroupBox groupBox2;
		#endregion

		#region ϐ/萔
		const string DEFAULT_PHOTO_EXTENTION = @"(jpg|png|gif|bmp)$";
		const int DEFAULT_PHOTO_WIDTH	= 100;
		const int DEFAULT_PHOTO_COUNT = 3;
		const string EXPORT_COLUMN_TITLE = @"̏d";
		enum DrawSpan {Week, Month, Year};
		enum DrawRange {Before, After};
		
		string PHOTO_DIR = Application.StartupPath + @"\photo";
		string THUMBNAIL_DIR = Application.StartupPath + @"\photo\thumbnail";

		User user;
		DrawSpan drawSpan;
		DrawRange drawRange;

		Hashtable visibleWeightHolder = null;
		Hashtable photoHolder = null;
		Hashtable visiblePhotoHolder = null;

		Graphics graphics;
		Graphics graphicsPhoto = null;

		double weightMax = 0.0;
		int currentDay = 0;
		#endregion

		#region RXgN^/fXgN^
		public HistoryPhotoForm(User user)
		{
			InitializeComponent();
			this.user = user;
			this.Text = "̏d: " + user.name;

			graphics = panelGraph.CreateGraphics();
			graphicsPhoto = panelPhoto.CreateGraphics();
			
			InitWeight();
			LoadPhoto();
			InitPhoto();

			UpdateGraphics();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#endregion

		#region Windows tH[ fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.panelGraph = new System.Windows.Forms.Panel();
			this.dateTimePickerStart = new System.Windows.Forms.DateTimePicker();
			this.comboBoxSpan = new System.Windows.Forms.ComboBox();
			this.label1 = new System.Windows.Forms.Label();
			this.comboBoxRange = new System.Windows.Forms.ComboBox();
			this.label2 = new System.Windows.Forms.Label();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.buttonUpdate = new System.Windows.Forms.Button();
			this.panelPhoto = new System.Windows.Forms.Panel();
			this.labelCurrentDay = new System.Windows.Forms.Label();
			this.buttonExport = new System.Windows.Forms.Button();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.SuspendLayout();
			// 
			// panelGraph
			// 
			this.panelGraph.Location = new System.Drawing.Point(8, 56);
			this.panelGraph.Name = "panelGraph";
			this.panelGraph.Size = new System.Drawing.Size(365, 250);
			this.panelGraph.TabIndex = 0;
			this.panelGraph.Paint += new System.Windows.Forms.PaintEventHandler(this.panelGraph_Paint);
			this.panelGraph.MouseMove += new System.Windows.Forms.MouseEventHandler(this.panelGraph_MouseMove);
			// 
			// dateTimePickerStart
			// 
			this.dateTimePickerStart.Location = new System.Drawing.Point(8, 16);
			this.dateTimePickerStart.Name = "dateTimePickerStart";
			this.dateTimePickerStart.Size = new System.Drawing.Size(128, 19);
			this.dateTimePickerStart.TabIndex = 1;
			// 
			// comboBoxSpan
			// 
			this.comboBoxSpan.Items.AddRange(new object[] {
															  "1T",
															  "1",
															  "1N"});
			this.comboBoxSpan.Location = new System.Drawing.Point(160, 16);
			this.comboBoxSpan.Name = "comboBoxSpan";
			this.comboBoxSpan.Size = new System.Drawing.Size(80, 20);
			this.comboBoxSpan.TabIndex = 2;
			this.comboBoxSpan.Text = "1T";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(136, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(24, 16);
			this.label1.TabIndex = 3;
			this.label1.Text = "";
			// 
			// comboBoxRange
			// 
			this.comboBoxRange.Items.AddRange(new object[] {
															   "O",
															   ""});
			this.comboBoxRange.Location = new System.Drawing.Point(248, 16);
			this.comboBoxRange.Name = "comboBoxRange";
			this.comboBoxRange.Size = new System.Drawing.Size(40, 20);
			this.comboBoxRange.TabIndex = 4;
			this.comboBoxRange.Text = "O";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(288, 24);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(24, 16);
			this.label2.TabIndex = 5;
			this.label2.Text = "܂";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.buttonUpdate);
			this.groupBox1.Controls.Add(this.comboBoxSpan);
			this.groupBox1.Controls.Add(this.label2);
			this.groupBox1.Controls.Add(this.comboBoxRange);
			this.groupBox1.Controls.Add(this.label1);
			this.groupBox1.Controls.Add(this.dateTimePickerStart);
			this.groupBox1.Location = new System.Drawing.Point(8, 0);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(368, 48);
			this.groupBox1.TabIndex = 0;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "\";
			// 
			// buttonUpdate
			// 
			this.buttonUpdate.Location = new System.Drawing.Point(320, 16);
			this.buttonUpdate.Name = "buttonUpdate";
			this.buttonUpdate.Size = new System.Drawing.Size(40, 20);
			this.buttonUpdate.TabIndex = 6;
			this.buttonUpdate.Text = "XV";
			this.buttonUpdate.Click += new System.EventHandler(this.buttonUpdate_Click);
			// 
			// panelPhoto
			// 
			this.panelPhoto.ForeColor = System.Drawing.Color.MediumPurple;
			this.panelPhoto.Location = new System.Drawing.Point(384, 72);
			this.panelPhoto.Name = "panelPhoto";
			this.panelPhoto.Size = new System.Drawing.Size(144, 232);
			this.panelPhoto.TabIndex = 1;
			// 
			// labelCurrentDay
			// 
			this.labelCurrentDay.Font = new System.Drawing.Font("MS UI Gothic", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
			this.labelCurrentDay.ForeColor = System.Drawing.Color.BlueViolet;
			this.labelCurrentDay.Location = new System.Drawing.Point(408, 56);
			this.labelCurrentDay.Name = "labelCurrentDay";
			this.labelCurrentDay.Size = new System.Drawing.Size(112, 16);
			this.labelCurrentDay.TabIndex = 2;
			this.labelCurrentDay.Text = "2006N00";
			// 
			// buttonExport
			// 
			this.buttonExport.Location = new System.Drawing.Point(32, 16);
			this.buttonExport.Name = "buttonExport";
			this.buttonExport.Size = new System.Drawing.Size(72, 20);
			this.buttonExport.TabIndex = 3;
			this.buttonExport.Text = "GNX|[g";
			this.buttonExport.Click += new System.EventHandler(this.buttonExport_Click);
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.buttonExport);
			this.groupBox2.Location = new System.Drawing.Point(384, 0);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(144, 48);
			this.groupBox2.TabIndex = 4;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "R}h";
			// 
			// HistoryPhotoForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(538, 312);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.labelCurrentDay);
			this.Controls.Add(this.panelPhoto);
			this.Controls.Add(this.panelGraph);
			this.Controls.Add(this.groupBox1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Name = "HistoryPhotoForm";
			this.Text = "̏d: ";
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region `֘A\bh
		
		private void buttonUpdate_Click(object sender, System.EventArgs e)
		{
			InitWeight();
			InitPhoto();
			UpdateGraphics();
		}
		
		private void panelGraph_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			UpdateGraphics();
		}

		private void panelGraph_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			int x = e.X;
			int y = e.Y;

			int dayLength = GetDayLength();
			double width =  (panelGraph.Width / dayLength);
			double yBase = (panelGraph.Height / weightMax);

			int day = 0;
			if(drawRange == DrawRange.After)
			{
				 day  = (int)((x - 1) / width);
			}
			else
			{
				 day = dayLength -  (int)((x + (width + 1)) / width);
			}
			if(day !=  currentDay)
			{
				currentDay = day;
				UpdateGraphics();
			}
		}

		void UpdateGraphics()
		{
			this.weightMax= GetWeightMax();

			Brush bg = Brushes.LightGray;
			Pen p = Pens.BlueViolet;
			Rectangle r = new Rectangle(0,0, panelGraph.Width-1,panelGraph.Height-1);

			//wĩNA
			graphics.FillRectangle(bg, r);	
			
			//10ȉ̏ꍇ͑̏dlȂ̂Ŕ`
			if(visibleWeightHolder.Count > 0)
			{
				//wi`
				DrawBackLines(weightMax);
				//̏dől`
				DrawMaxValue(weightMax);
				//Ot̕`
				DrawGraph(weightMax);
				//ʐ^̕`
				DrawPhoto();
				//݂̓t`
				DrawDate();
			}
			//wig̕`
			graphics.DrawRectangle(p, r);

			panelGraph.Update();
		}

		//̏dől`
		void DrawMaxValue(double weightMax)
		{
			string text = string.Format("Max:{0}kg", (int)(weightMax));
			Rectangle r = new Rectangle(2,2,60,12);
			graphics.DrawString(text,this.Font,Brushes.BlueViolet, r);	
		}

		//wi`
		void DrawBackLines(double weightMax)
		{
			int max = (int)(weightMax / 10);
			int x, y;

			for(int i=0; i<max;i++)
			{
				x = panelGraph.Width;
				y = (int)(panelGraph.Height - i * 10 * (panelGraph.Height / weightMax));
				graphics.DrawLine(Pens.LightCyan,0,y,x,y);
			}			
		}

		//t`
		void DrawDate()
		{
			DateTime date;
			if(drawRange == DrawRange.After)
			{
				date = dateTimePickerStart.Value.AddDays(currentDay);
			}
			else
			{
				date = dateTimePickerStart.Value.AddDays(-currentDay);
			}
			labelCurrentDay.Text = String.Format("{0}N{1}{2}",date.Year, date.Month, date.Day);
		}

		//Ot`
		void DrawGraph(double weightMax)
		{
			int x = 0, y= 0;
			int dayLength = GetDayLength();
			double width = (panelGraph.Width / dayLength);
			double yBase = (panelGraph.Height / weightMax);
		
			foreach(int day in visibleWeightHolder.Keys)
			{
				Pen p;
				Brush b;
				
				if(day == 0)
				{
					b = Brushes.LightYellow;
					p = Pens.DarkRed;
				}
				else if(day == currentDay)
				{
					b = Brushes.LightGoldenrodYellow;
					p = Pens.DarkRed;
				}
				else
				{
					b = Brushes.AliceBlue;
					p = Pens.BlueViolet;
				}
				
				double weight;
				Rectangle r;

				if(drawRange == DrawRange.After)
				{
					weight = (double)visibleWeightHolder[day];
					x = (int)(day * width + 1);
					y = (int)(yBase * weight);
					r = new Rectangle(x,panelGraph.Height - y,(int)width,panelGraph.Height);
				}
				else
				{
					weight = (double)visibleWeightHolder[day];
					x = (int)((dayLength - day) * width - (width + 1));
					y = (int)(yBase * weight);
					r = new Rectangle(x,panelGraph.Height - y,(int)width,panelGraph.Height);
				}

				if(width > 1)
				{
					graphics.FillRectangle(b,r);
					graphics.DrawRectangle(p,r);
				}
				else
				{
					graphics.DrawLine(p,x,panelGraph.Height-y,x,panelGraph.Height);
				}	
			}
		}

		//ʐ^`
		void DrawPhoto()
		{
			int x = 0;
			int y = 5;

			graphicsPhoto.Clear(Panel.DefaultBackColor);
			
			if(visiblePhotoHolder.Contains(currentDay))
			{
				BitmapArray ba = (BitmapArray)visiblePhotoHolder[currentDay];
			
				foreach(Bitmap bitmap in ba.GetAll())
				{
					if(bitmap != null)
					{
						x = (panelPhoto.Width - bitmap.Width) / 2;
						graphicsPhoto.DrawImage(bitmap, x, y);
						y += bitmap.Height + 5;
					}
				}		
			}
			panelPhoto.Update();
		}

		#endregion

		#region ʐ^̓Ǎ/i֘A\bh

		void LoadPhoto()
		{
			photoHolder = new Hashtable();
			
			if(!Directory.Exists(PHOTO_DIR))
				Directory.CreateDirectory(PHOTO_DIR);

			if(!Directory.Exists(THUMBNAIL_DIR))
				Directory.CreateDirectory(THUMBNAIL_DIR);

			string [] originalFiles= Directory.GetFiles(PHOTO_DIR);
			string [] thumbFiles = Directory.GetFiles(THUMBNAIL_DIR);

			foreach (string file in originalFiles)
			{
				//int index = Array.BinarySearch(thumbFiles,
				//	Path.GetFileNameWithoutExtension(file),);
				int index = FindElement(thumbFiles,Path.GetFileNameWithoutExtension(file));
				Bitmap b = null;
				DateTime d;
				if(index < 0)
				{
					b = CreateBitmap(file);
					d = File.GetLastWriteTime(file);
					string thumbFile = THUMBNAIL_DIR + @"\" + 
						Path.GetFileNameWithoutExtension(file) + ".jpg";
					b.Save(thumbFile, ImageFormat.Jpeg);
					File.SetLastWriteTime(thumbFile, d);
				}
				else
				{
					b = CreateBitmap(thumbFiles[index]);
					d = File.GetLastWriteTime(thumbFiles[index]);
				}

				if(!photoHolder.Contains(d))
				{
					if(b != null)
						photoHolder.Add(d, b);
				}
			}	
		}

		int FindElement(string [] array, string targetStr)
		{
			int result = -1;
			for (int i=0;i<array.Length;i++)
			{
				Match m = Regex.Match(array[i], targetStr);
				if(m.Success)
				{
					result = i;
					break;
				}
			}
			return result;
		}

		void InitPhoto()
		{
			//visiblePhotoHolder.Clear();
			visiblePhotoHolder = new Hashtable();

			DateTime dateBase = dateTimePickerStart.Value.Date;
			TimeSpan spanTarget= new TimeSpan(GetDayLength(),0,0,0,0);

			foreach(DateTime d in photoHolder.Keys)
			{
				long diffTicks;

				if(drawRange == DrawRange.After)
					diffTicks = d.Date.Ticks - dateBase.Ticks;
				else
					diffTicks =  dateBase.Ticks - d.Date.Ticks;
				
				if(diffTicks >= 0 && diffTicks <= spanTarget.Ticks)
				{
					int day = (int)(diffTicks / (24 * 60 * 60 * (long)10000000));
					
					if(!visiblePhotoHolder.Contains(day))
					{
						BitmapArray ba = new BitmapArray(DEFAULT_PHOTO_COUNT, (Bitmap)photoHolder[d]);
						visiblePhotoHolder.Add(day, ba);
					}
					else
					{	
						BitmapArray ba = (BitmapArray)visiblePhotoHolder[day];
						if(ba.Add((Bitmap)photoHolder[d]))
							visiblePhotoHolder[day] = ba;
					}
				}
			}
		}
		
		Bitmap CreateBitmap(string file)
		{
			Bitmap bitmap = null;
			if(File.Exists(file))
			{
				Match m = Regex.Match(file, DEFAULT_PHOTO_EXTENTION,
					RegexOptions.IgnoreCase);
				
				if(m.Success)
				{
					try
					{
						Bitmap b = (Bitmap)Bitmap.FromFile(file);
						int width = DEFAULT_PHOTO_WIDTH;
						int height = (int)(b.Height * (width / (double)b.Width));			
						bitmap = new Bitmap(b, width, height);
					}
					catch
					{
						Thread.Sleep(1);
					}
				}
			}
			return bitmap;
		}

		#endregion

		#region GNX|[g֘A\bh
		private void buttonExport_Click(object sender, System.EventArgs e)
		{
			InitWeight();
			InitPhoto();
			UpdateGraphics();
		
			SaveFileDialog dialog = new SaveFileDialog();
			dialog.InitialDirectory = 
				Environment.GetFolderPath(Environment.SpecialFolder.DesktopDirectory);
			dialog.Filter = "csv file (*.csv)|*.csv";
			dialog.RestoreDirectory = true;
			
			if (dialog.ShowDialog() == DialogResult.OK)
			{	
				string [] lines = GetWeightArray();
				ExportWeightArray(dialog.FileName, lines);
			}

		}

		string [] GetWeightArray()
		{
			string []lines = new string[GetDayLength()];
			foreach(int day in visibleWeightHolder.Keys)
			{
				DateTime date;
				if(drawRange == DrawRange.After)
				{
					date = dateTimePickerStart.Value.AddDays(day);
				}
				else
				{
					date = dateTimePickerStart.Value.AddDays(-day);
				}

				if(day < lines.Length)
				{
					lines[day] = String.Format("{0},{1}", 
						date.ToShortDateString(), (double)visibleWeightHolder[day]);
				}
			}
			return lines;
		}

		void ExportWeightArray(string filename, string [] lines)
		{
			StreamWriter writer = null;
			try
			{
				writer = new StreamWriter(filename,false,Encoding.GetEncoding(932));
				writer.WriteLine(",{0}", EXPORT_COLUMN_TITLE);
				foreach(string line in lines)
				{
					if(line != "" && line != null)
					{
						writer.WriteLine(line);
					}
				}	
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.Message);
			}
			finally
			{
				if(writer != null)
					writer.Close();
			}
		}

		#endregion

		#region ̏d̍i֘A\bh
		void InitWeight()
		{
			drawSpan = (DrawSpan)comboBoxSpan.SelectedIndex;
			drawRange = (DrawRange)comboBoxRange.SelectedIndex;

			visibleWeightHolder = new Hashtable();
			//visibleWeightHolder.Clear();
			DateTime dateBase = dateTimePickerStart.Value.Date;
			TimeSpan targetSpan = new TimeSpan(GetDayLength(),0,0,0,0);

			try
			{
				if(user.weightHolder.Count == 0)
					return;

				foreach(DateTime d in user.weightHolder.Keys)
				{
					long diffTicks;
					if(drawRange == DrawRange.After)
					{
						diffTicks = d.Date.Ticks - dateBase.Ticks;
					}
					else
					{
						diffTicks =  dateBase.Ticks - d.Date.Ticks;
					}

					if(diffTicks >= 0 && diffTicks <= targetSpan.Ticks)
					{
						//1ticks = 100nsec
						//1sec = 10000000 = 10 * 1000 * 1000 ticks
						//1day = 24 * 60 * 60 * 10000000
						int day = (int)(diffTicks / (24 * 60 * 60 * (long)10000000));
					
						if(!visibleWeightHolder.Contains(day))
						{
							visibleWeightHolder.Add(day, user.weightHolder[d]);
						}
					}
					
				}
			}
			catch(Exception ex)
			{
				Thread.Sleep(1);
			}
		}
		#endregion

		#region ̑̃\bh
		int GetDayLength()
		{
			int result;
			switch(drawSpan)
			{
				case DrawSpan.Week:
					result = 7;
					break;
				case DrawSpan.Month:
					result = 31;
					break;
				case DrawSpan.Year:
					result = 365;
					break;
				default:
					result = 7;
					break;
			}
			return result;
		}

		int GetWeightMax()
		{
			double max = 0;
			int result = 0;
			foreach(double weight in visibleWeightHolder.Values)
			{
				if(max < weight)
					max = weight;
			}
			result = (int)(max / 10) * 10 + 10;
			return result;
		}

		#endregion

		#region Class:BitmapArray
		class BitmapArray
		{
			Bitmap [] bitmaps;
			public int cnt = 0;
			public int cntMax = 0;

			public BitmapArray(int cntMax, Bitmap bitmap)
			{
				this.cntMax = cntMax;
				this.bitmaps = new Bitmap[cntMax];
				this.bitmaps[0] = bitmap;
				cnt++;
			}

			public bool Add(Bitmap bitmap)
			{
				bool result;
				if(cnt < cntMax) 
				{
					bitmaps[cnt] = bitmap;
					cnt++;
					result = true;
				}
				else
				{
					result = false;
				}
				return result;
			}
			
			public Bitmap [] GetAll()
			{
				return bitmaps;
			}
		}
		#endregion
	}
}
